// prosta rampa do jazdy w te i we wte, pitsa 2012-4-16
// http://www.cnc.info.pl/topics65/rampa-na-arduino-vt35799.htm

#define enable 4     // enable do sterownika M545 z Alegro od markcomp77 
#define DIR_PIN 5    // dir do sterownika M545 z Alegro od markcomp77 
#define STEP_PIN 6   // reklama cd.: silnik 57H76-2008B, 1.9Nm, 2.83A od MARKcomp77@o2.pl

int  podzial=8;      // testowe ruchy silnika ustawione na pełny obrót
                     // zmieniając podział na sterowniku zmień tą liczbę aby mieć pełny obrót 

void setup()
{
//  Serial.begin(9600);  // test wyliczanych czasów 
  pinMode(enable, OUTPUT);
  pinMode(DIR_PIN, OUTPUT);
  pinMode(STEP_PIN, OUTPUT);
}

void loop() {

delay(4000);

rampa(200*podzial, 10000, 140, 50); 
rampa(-200*podzial, 10000, 140, 50); 

rampa(200*podzial, 5000, 180, 25); 
rampa(-200*podzial, 5000, 180, 25); 

delay(2000);

rampa(200*podzial, 10000, 350, 20);
rampa(-200*podzial, 10000, 350, 20); 

rampa(200*podzial, 10000, 250, 20); 
rampa(-200*podzial, 10000, 250, 20); 

delay(6000);

 for(int hyhy=20 ; hyhy > 2 ; hyhy = hyhy - 1){
   rampa(200*podzial, 5000, 50+hyhy*10, 20); 
   rampa(-200*podzial, 5000, 50+hyhy*10, 20); 
 }
 for(int hyhy=2 ; hyhy < 20 ; hyhy = hyhy + 1){
   rampa(200*podzial, 5000, 50+hyhy*10, 20); 
   rampa(-200*podzial, 5000, 50+hyhy*10, 20); 
 }
delay(4000);
}

void rampa(int steps, int startsteps, int speedm, int speedd){
  // steps - liczba kroków do wykonania - ujemna liczba zmiana kierunku 
  // startsteps - czas startowego kroku us np. 2000
  // speedm - minimalny czas us między krokami na pełnej prędości
  // speedd - delta t us 
  int przerwa = 20;
  int licz = 0;       // licznik zrobionych kroków
  int krokirampy= 0;  
  int korekta= 6;     // trzeba jeszcze kroki doliczyć - tymczasowa poprawka 
  int pip = 20;                      // 20us - impuls step
  int dir = (steps > 0)? HIGH:LOW;
  steps = abs(steps);                // wyciągnięcie kierunku z podanej liczby kroków.
  digitalWrite(DIR_PIN,dir);         // ustaw kierunek

//  Serial.print("poczatek");
//  Serial.println(steps);
  for(int i= startsteps; i > 1 ; i = i / 1.09 - 1){
    licz=licz+1;
    przerwa=i+speedd;
    if (przerwa < speedm) {przerwa = speedm ; } ;
    digitalWrite(STEP_PIN, HIGH);
    delayMicroseconds(pip); 
    digitalWrite(STEP_PIN, LOW);
    delayMicroseconds(przerwa);
//    Serial.println(przerwa);
  } 
//    Serial.print("licz=");
//    Serial.println(licz);
    krokirampy=licz;
  for(int i=0; i < (steps-2*krokirampy-korekta); i++ ) {
    licz=licz+1;
    digitalWrite(STEP_PIN, HIGH);
    delayMicroseconds(pip); 
    digitalWrite(STEP_PIN, LOW);
    delayMicroseconds(speedm);
//    Serial.println(speedm);
  }
//    Serial.print("licz=");
//    Serial.println(licz);
//  Serial.println("koniec");
  for(int i=1; i < startsteps; i = i * 1.09 + 1){
    licz=licz++;
    przerwa=i+speedd;
    if (przerwa < speedm) {przerwa = speedm ; } ;
    digitalWrite(STEP_PIN, HIGH);
    delayMicroseconds(pip); 
    digitalWrite(STEP_PIN, LOW);
    delayMicroseconds(przerwa);
//    Serial.println(przerwa);
  } 
//    Serial.print("licz=");
//    Serial.println(licz);

//    Serial.print("zrobione");
  
} 

